
//
// This class extends qtextedit for information about file and location
//

#include <qtextedit.h>
#include <qtabwidget.h>
//#include <qrect.h> 

class FileEdit : public QTextEdit
{
    Q_OBJECT

 public:
    FileEdit(QWidget *parent = 0, const char *name = 0);
    ~FileEdit();
    void init();
   
    // File description options
    
    // Set short and long filename, set tab location
    void    set(const char *filename, const char *path, int tab=0);
    // True is fileeditor contains the file
    bool        equals(const char *filepath);
    void        setNext(FileEdit *configFile);
    FileEdit *getNext();
    int        getTab();
    void      setTab(int num);
    QString getFileName();
    QString getPath();
    bool findString( QString searchString, bool direction, bool optionCS, bool optionWO );
   
    void minimize();
    void save();
    void close();
    
signals:
    void selected(QString);
    void closed(FileEdit * fileedit);
    
public slots:
    void handleSelected();

private:
    QString *filetext;    
    QString *pathtext;
    int         tabnum;
    FileEdit *nextItem;    
};

