/**************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename slots use Qt Designer which will
** update this file, preserving your code. Create an init() slot in place of
** a constructor, and a destroy() slot in place of a destructor.
*****************************************************************************/

#include <qtabwidget.h>
#include <qfiledialog.h>
#include <qcheckbox.h>
#include <qradiobutton.h>
#include <qdir.h>
//#include <qcolor.h>

//#include ".ui/notice.h"
//#include ".ui/inputdialog.h"
//#include ".ui/subwindow.h"
//#include ".ui/setupwindow.h"
//#include ".ui/finddialog.h"

// #include "fileedit.h"
//#include "expat.h"

// ***************************************************
//   Class functions
// ***************************************************

void MainWindow::init()
{
    //SetupWindow *setupWin = new SetupWindow(this, "",WStyle_Customize | WStyle_DialogBorder | WStyle_Title);
    setupWin = new SetupWindow();
    //setupWin->show();
    QString *errorStr = setupWin->readConfigFile(CONFIG_FILE);
    setupWin->show();
    if ( !errorStr->isEmpty() )
        notice(tr("Environment"),QString(tr("Error, in reading config file")+" \""+ CONFIG_FILE +"\":\n" + *errorStr), tr("OK"), "", "", "");
     connect( this, SIGNAL( closed() ), setupWin, SLOT( close() ));

    // Ensure Menu Color are defined
    //QColor grey1 = QColor(192, 192, 192);
    /*QColor grey1 = QColor(224, 224, 224);
    menubar->setPaletteBackgroundColor ( grey1 );
    fileMenu->setPaletteBackgroundColor ( grey1 );
    editMenu->setPaletteBackgroundColor ( grey1 );
    setupMenu->setPaletteBackgroundColor ( grey1 );
    processMenu->setPaletteBackgroundColor ( grey1 );
    PopupMenu->setPaletteBackgroundColor ( grey1 );
    helpMenu->setPaletteBackgroundColor ( grey1 );*/
    setPalette(QPalette(setupWin->getColor(1), setupWin->getColor(3)) );
    fileMenu->setPalette(QPalette(setupWin->getColor(1), setupWin->getColor(2)) );
    //statusBar()->close();
    // Update geometry of tools
    TextLabel1->resize(TextLabel1->sizeHint());
    LineNumberBox->resize(LineNumberBox->sizeHint().width()+4, LineNumberBox->height());
    LineNumberBox->hide();
    TextLabel1_2->resize(TextLabel1_2->sizeHint());
    SearchBox->resize(SearchBox->sizeHint().width()+4, SearchBox->height());
    SearchBox->hide();
    delete TabWidget->currentPage();
    fileNew();
    connect( this, SIGNAL( selectedText(QString) ), this, SLOT( setSearchBoxText(QString) ));
    connect( StatusText, SIGNAL( processFinished(int, bool) ), this, SLOT( handleprocessFinished(int, bool) ));
}


// ***************************************************
//   Menu functions
// ***************************************************

void MainWindow::fileNew()
{
    FileEdit *fileEdit = new FileEdit( TabWidget );

    QFont newfont( font() );
    newfont.setFamily( "Lucidatypewriter" );
    newfont.setPointSize( 8 );
    newfont.setBold( false );
    fileEdit->setFont( newfont ); 

    // Create new empty descrition;
    fileEdit->setTextFormat( PlainText );
    TabWidget->addTab( fileEdit, tr("empty") );
    TabWidget->setCurrentPage(TabWidget->count()-1);
    TabWidget->showPage(TabWidget);
    fileEdit->set("", "", TabWidget->count()-1);
    
    if (TabWidget->count() == 1)
    {
	baseFileEdit = fileEdit;
    }
    else
    {
	((FileEdit*)TabWidget->page(TabWidget->count()-2))->setNext(fileEdit);
    }
    
    connect( fileEdit, SIGNAL( modificationChanged(bool) ), this, SLOT( setModifiedTitle(bool) ) );
    connect( fileEdit, SIGNAL( cursorPositionChanged(int,int) ), this, SLOT( setLineNumber(int,int) ) );
    connect( fileEdit, SIGNAL( selected(QString) ), this, SLOT( handleSelectedText(QString) ));
    connect( fileEdit, SIGNAL( closed(FileEdit *) ), this, SLOT(  askSave(FileEdit *) ));
}


void MainWindow::fileOpen()
{
    QDir *dir = new QDir;
    dir->setFilter( QDir::Files | QDir::Hidden | QDir::NoSymLinks );
    QFileDialog filedialog;
    filedialog.setShowHiddenFiles(true);
    //QStringList openfilename = QFileDialog::getOpenFileNames( tr( "C/C++ files (*.c *.cpp *.c++ *.gpp *.g++ *.h);;Web files (*.htm *.html);;Project file list (*.dir);;All Files (*)"), dir->absPath(), this );
    QStringList::Iterator singleFile;
    QStringList openfilename = filedialog.getOpenFileNames( tr( "C/C++ files (*.c *.cpp *.c++ *.gpp *.g++ *.h *.pro);;Web files (*.htm *.html);;Project file list (*.dir);;All Files (*)"), dir->absPath(), this, 0, tr("Open file(s)") );   
    for ( singleFile = openfilename.begin(); singleFile != openfilename.end(); singleFile++)
    {
	if ( !(*singleFile ).isEmpty() )
	    fileLoad(*singleFile);
    }
}

void MainWindow::fileSave()
{
    Save ((FileEdit *) TabWidget->currentPage());
}

void MainWindow::fileSaveAs()
{
    SaveAs ((FileEdit *) TabWidget->currentPage());
}

void MainWindow::filePrint()
{

}

void MainWindow::fileExit()
{
    if ( notice(tr("Quit"),tr("Confirm exiting xwb2"), tr("Quit"), "", tr("Cancel"), "") == QDialog::Accepted )
    {
	emit( closed() );
	for (int i=0; i < TabWidget->count(); i++)
	{
	    ((FileEdit *) TabWidget->page(i))->close();
	}
	this->close();
    }
    // necessary?
    //disconnect( this, SIGNAL( closed() ), setupWin, SLOT( close() ));
}

void MainWindow::editUndo()
{
    FileEdit *currTextEdit = (FileEdit*)TabWidget->currentPage();
    currTextEdit->undo();
}

void MainWindow::editRedo()
{
    FileEdit *currTextEdit = (FileEdit*)TabWidget->currentPage();
    currTextEdit->redo();
}

void MainWindow::editCut()
{
    FileEdit *currTextEdit = (FileEdit*)TabWidget->currentPage();
    if (currTextEdit->hasSelectedText())
    { currTextEdit->cut(); }
}

void MainWindow::editCopy()
{
    FileEdit *currTextEdit = (FileEdit*)TabWidget->currentPage();
    if (currTextEdit->hasSelectedText())
    { currTextEdit->copy(); }
}

void MainWindow::editPaste()
{
    FileEdit *currTextEdit = (FileEdit*)TabWidget->currentPage();
    currTextEdit->paste();
}

void MainWindow::editFindShort()
{
    FileEdit *currTextEdit = (FileEdit*)TabWidget->currentPage();
    // MaximizeSearch;
    SearchButton->hide();
    SearchBox->show();
    SearchBox->raise();
    FindString->setFocus();
    
    if (currTextEdit and currTextEdit->hasSelectedText())
    { 
	FindString->setText(currTextEdit->selectedText().section("\n", 0, 0) );
    }
    else
    { 
	FindString->setText("");
    }
}

void MainWindow::editFind()
{
    showSearchDialog(TabWidget->currentPage());
}

void MainWindow::editGotoLine()
{
    LineNumberButton->hide();
    LineNumberBox->show();
    LineNumberBox->raise();
    LineNumber->setFocus();
    LineNumber->setText("");
}


void MainWindow::helpIndex()
{

}

void MainWindow::helpContents()
{

}

void MainWindow::helpAbout()
{

}


void MainWindow::helpAboutAction_activated()
{

}


// ***************************************************
//   Processing functions
// ***************************************************

void MainWindow::compile()
{
    CompileButton->setEnabled(false);
    if ( !StatusText->run(tr("make")) )
    {
	notice(tr("Compile"),QString(tr("Could not start process")+" \""+"make" + "\" "), tr("OK"), "", "", "");
    }
}

void MainWindow::runX()
{
    RunXButton->setEnabled(false);
    RunXButton->setEnabled(false);

}

void MainWindow::run()
{
    RunXButton->setEnabled(false);
    RunXButton->setEnabled(false);

}


// ***************************************************
//   Process extern signals
// ***************************************************

void MainWindow::editExtern()
{   
    // Create new Widget with filename as title if more than one  tabwidget exists
    if (TabWidget->count() > 1)
    {
	FileEdit *fileEdit;
	SubWindow *subWindow = new SubWindow();
	
	// Move from current position to end of tab List
	fileEdit = (FileEdit *)TabWidget->currentPage();
	FileEdit *lastintab = (FileEdit*)TabWidget->page(TabWidget->count()-1);
	if (lastintab != fileEdit)
	{ 	  
	    if (TabWidget->currentPageIndex()>0)
	    {
		( (FileEdit *)TabWidget->page(TabWidget->currentPageIndex()-1) ) -> setNext(fileEdit->getNext() );
	    }
	    fileEdit->setNext( lastintab->getNext() );
	    lastintab->setNext(fileEdit); 
	}
		
	// Set Tab number for extern FileEdit to invalid
	fileEdit->setTab(-1);	
	
	// redefine fileConfig for extern Widget
	disconnect( fileEdit, SIGNAL( modificationChanged(bool) ), this, SLOT( setModifiedTitle(bool) ) );
	disconnect( fileEdit, SIGNAL( cursorPositionChanged(int,int) ), this, SLOT( setLineNumber(int,int) ) );
	subWindow->setCaption( TabWidget->tabLabel(fileEdit));
	delete subWindow->SubTextEdit;
	subWindow->SubTextEdit = fileEdit;
	fileEdit->reparent( subWindow->GroupWidget, QPoint(30,0) );
	fileEdit->resize(subWindow->width()-30, subWindow->height());
	int para, pos;
	fileEdit->getCursorPosition( &para, &pos );
	subWindow->setLineNumber( para, pos );
	// Create connections for subwindow here, cannot be done by subwindow
	connect( fileEdit, SIGNAL( modificationChanged(bool) ), subWindow, SLOT( setModifiedTitle(bool) ));
	connect( fileEdit, SIGNAL( cursorPositionChanged(int,int) ), subWindow, SLOT( setLineNumber(int,int) ) );
	connect( fileEdit, SIGNAL( selected(QString) ), subWindow, SLOT( handleSelectedText(QString) ));
	connect( fileEdit, SIGNAL( selected(QString) ), subWindow, SLOT( setSearchBoxText(QString) ));
	connect( subWindow, SIGNAL( minimized(QWidget *) ), this, SLOT( editIntern(QWidget *) ));
	connect( subWindow, SIGNAL( closed(QWidget *) ), this, SLOT( closeextern(QWidget *) ));
	connect( subWindow, SIGNAL( saved(FileEdit *) ), this, SLOT( Save(FileEdit *) ));

	connect( this, SIGNAL( closed() ), subWindow, SLOT( fileExit() ));
	
	// Adjust tab numbers 
	for (int i=0; i < TabWidget->count(); i++)
	{
	    ((FileEdit *) TabWidget->page(i))->setTab(i);
	}
	
	subWindow->show();
    }
}

void MainWindow::closeExternSignals( QWidget * sender )
{
    disconnect( ((SubWindow *)sender)->SubTextEdit, SIGNAL( modificationChanged(bool) ), sender, SLOT( setModifiedTitle(bool) ));
    disconnect( ((SubWindow *)sender)->SubTextEdit, SIGNAL( cursorPositionChanged(int,int) ), sender, SLOT( setLineNumber(int,int) ) );    
    disconnect( ((SubWindow *)sender)->SubTextEdit, SIGNAL( selected(QString) ), sender, SLOT( setSearchBoxText(QString) ));
    disconnect( ((SubWindow *)sender)->SubTextEdit, SIGNAL( selected(QString) ), sender, SLOT( handleSelectedText(QString) ));
    disconnect( ((SubWindow *)sender)->SubTextEdit, SIGNAL( closed(FileEdit *) ), this, SLOT(  askSave(FileEdit *) ));
    
    disconnect( sender, SIGNAL( minimized(QWidget *) ), this, SLOT( editIntern(QWidget *) ));
    disconnect( sender, SIGNAL( closed(QWidget *) ), this, SLOT( closeextern(QWidget *) ));
    disconnect( sender, SIGNAL( saved(FileEdit *) ), this, SLOT( Save(FileEdit *) ));

    disconnect( this, SIGNAL( closed() ), sender, SLOT( fileExit() ));
}

void MainWindow::closeextern( QWidget * sender )
{
    FileEdit *fileEdit;
    FileEdit *currFileEdit = ((SubWindow *)sender)->SubTextEdit;
    
     closeExternSignals( sender );
   
   for ( fileEdit = (FileEdit *)TabWidget->page(0); fileEdit->getNext() != NULL && fileEdit->getNext() != currFileEdit; fileEdit = fileEdit->getNext() )
    {
    }

   // Delete sender fileEdit from the list and close subWindow
    fileEdit->setNext( currFileEdit->getNext() );
    sender->close();
    //delete sender;
}

void MainWindow::editIntern(QWidget* sender)
{
    FileEdit *fileEdit;
    FileEdit *currFileEdit = ((SubWindow *)sender)->SubTextEdit;
	
    // Inactivate extern Window Signals, activate intern Behaviour in the end
    closeExternSignals( sender );
    
    // Insert sender fileEdit at the end of Tab, without losing extern Widgets 
    for ( fileEdit = (FileEdit *)TabWidget->page(0); fileEdit->getNext() != NULL && fileEdit->getNext() != currFileEdit; fileEdit = fileEdit->getNext() )
    {  }
    fileEdit->setNext(currFileEdit->getNext());
    currFileEdit->setNext( ((FileEdit*) TabWidget->page(TabWidget->count()-1) )->getNext() );
    ( (FileEdit*) TabWidget->page(TabWidget->count()-1) )->setNext(currFileEdit);
    
    // Update Tab number for intern FileEdit (reparent)
    currFileEdit->setTab(TabWidget->count());
    TabWidget->addTab( currFileEdit, sender->caption());
    fileEdit->resize(TabWidget->width(), TabWidget->height());
    currFileEdit->show();
    TabWidget->setCurrentPage(TabWidget->count()-1);
    TabWidget->showPage(TabWidget);
    sender->close();
	
    connect( currFileEdit, SIGNAL( modificationChanged(bool) ), this, SLOT( setModifiedTitle(bool) ) );
}



// ***************************************************
//   Error message Window functions
// ***************************************************

void MainWindow::errLast()
{

}

void MainWindow::errFirst()
{

}

void MainWindow::errPrev()
{

}

void MainWindow::errNext()
{

}

void MainWindow::procExtern()
{

}


// ***************************************************
//   Popup / Extern Window functions
// ***************************************************

int MainWindow::notice(const char* caption, const char* title, const char* acceptText, const char* refuseText, const char* cancelText, const char* helpmessage)
{
    NoticeWindow *notice = new NoticeWindow(this, "",WStyle_Customize | WStyle_DialogBorder | WStyle_Title); 
   
    QStringList messagelist = QStringList::split("\n", helpmessage);
    while (messagelist.count() < 3)
    { messagelist.append(""); }
    
    notice->setLabels(title, acceptText, refuseText, cancelText, messagelist[0], messagelist[1] );
    notice->setCaption( caption );
    int result = notice->exec();
    notice->set_size();
    return result;
}


int MainWindow::inputDialog( const char * caption, const char * title, const char * acceptText, const char *input, const char * helpmessage)
{

    InputDialog *dialog = new InputDialog(this); 
   
    dialog->setLabels(title, acceptText, input, helpmessage);
    dialog->setCaption( caption );
    // dialog->update(10, 10, dialog->width(), dialog->height()); 
    return dialog->exec();
}


// ***************************************************
//   Behavior / Action functions
// ***************************************************

void MainWindow::fileLoad( const QString &f )
{
    FileEdit *fileEdit;
    bool isReadOnly = false;
	
    // Open file
    if ( !QFile::exists( f ) )
	return;
    QFile file( f );
    if ( !file.open( IO_ReadWrite ) )
    { 
	if ( !file.open( IO_ReadOnly ) )
 	{ return; }
	else
	{ isReadOnly = true; }
     }
    QTextStream ts( &file );
    QString txt = ts.read();
     // Show Formatted Text -- to be implemented later
    /* if ( !QStyleSheet::mightBeRichText( txt ) )
     { 
	txt = QStyleSheet::convertFromPlainText( txt, QStyleSheetItem::WhiteSpacePre ); 
	fileEdit->setRTFormat(true);
     } */

    // Check if file is already used, then show or reload,
    for (fileEdit = (FileEdit*)TabWidget->page(0); fileEdit != NULL; fileEdit = fileEdit->getNext())
    {
	    if (fileEdit->equals(QFileInfo( f ).filePath()))
	    {
		// Set tabWidget position or extern Widget with chosen file
		if (fileEdit->getTab() >= 0)
		{
		    TabWidget->setCurrentPage(fileEdit->getTab());
		    TabWidget->showPage(TabWidget);
		}
		
		if (fileEdit->isModified())
		{	  
		
		    if ( notice(tr("Reload"), QString(tr("Reload file") +" \""+QFileInfo( f ).fileName() +  "\""), tr("Reload"), "", tr("Cancel"), tr("This file has been edited;\nreload will discard any changes")) == QDialog::Accepted)
		    { fileEdit->setText( txt ); }
		}
		
		if (fileEdit->getTab() < 0)
		{
		    ((QWidget *) fileEdit->topLevelWidget())->setActiveWindow(); 
		    ((QWidget *) fileEdit->topLevelWidget())->raise(); 
		}
		
		return;
	    }
	}
    
     // Check if there are unused "new" tabs and use then first for files
    for (fileEdit = (FileEdit*)TabWidget->page(0); fileEdit != NULL; fileEdit = fileEdit->getNext())
    {
	 if (fileEdit->equals("") && fileEdit->length()==0)
	 {    
	   fileEdit->setText( txt );
	   // Set Label and editor behavior
	   if (isReadOnly)   
	   {	
	       TabWidget->setTabLabel(TabWidget->page(fileEdit->getTab()), QFileInfo( f ).fileName() + QString(tr(" (readonly)")));
	       fileEdit->setUndoDepth(0);
	       fileEdit->setReadOnly(true);
	   }	  
	   else
	   {	
	       TabWidget->setTabLabel(TabWidget->page(fileEdit->getTab()), QFileInfo( f ).fileName());
	   }	  
	   // Set File Information
	   fileEdit->set(QFileInfo( f ).fileName(), QFileInfo( f ).filePath(), fileEdit->getTab());
	   // Show / raise Window
	   if (fileEdit->getTab() >= 0)
	   {	   
	       TabWidget->setCurrentPage(fileEdit->getTab());
	       TabWidget->showPage(TabWidget);
	   }
	   else
	   {
	       ((QWidget *) fileEdit->topLevelWidget())->setActiveWindow(); 
	       ((QWidget *) fileEdit->topLevelWidget())->raise(); 
	   }	  
	   
	  return;
	}
    }
	
      // Create new tab item and
     // append new file information to list
      fileEdit  = new FileEdit( TabWidget );
      
      QFont newfont( font() );
      newfont.setFamily( "Lucidatypewriter" );
      newfont.setPointSize( 11 );
      newfont.setBold( false );
      fileEdit->setFont( newfont ); 
    
      fileEdit->setTextFormat( PlainText );
      // Set Label and editor behavior
      if (isReadOnly)   
      {	
	  TabWidget->addTab( fileEdit, QFileInfo( f ).fileName() + QString(tr(" (readonly)")));
	  fileEdit->setUndoDepth(0);
	  fileEdit->setReadOnly(true);
      }	      
      else
      {	
	  TabWidget->addTab( fileEdit, QFileInfo( f ).fileName() );
      }	 
      fileEdit->setText( txt );
      fileEdit->set( QFileInfo( f ).fileName(), QFileInfo( f ).filePath(),  TabWidget->count()-1);
      TabWidget->setCurrentPage(TabWidget->count()-1);
}

void MainWindow::findNext()
{
    QString searchString = QString(FindString->text());
    FileEdit *currTextEdit = (FileEdit*)TabWidget->currentPage();
  
    if (searchString != "")
    { currTextEdit->findString(searchString, true, false, false); }
}

void MainWindow::findPrev()
{
    QString searchString = QString(FindString->text());
    FileEdit *currTextEdit = (FileEdit*)TabWidget->currentPage();
    
    if (searchString != "")
    { currTextEdit->findString(searchString, false, false, false); }
}

void MainWindow::find( QWidget * widget, bool direction)
{   
    FindDialog *findDialog = (FindDialog *) widget;
    FileEdit *currTextEdit = (FileEdit*)TabWidget->currentPage();

    // Get selected options
    QString searchString = QString(findDialog->SearchString->text());
    bool optionCS =  findDialog->OptionCS->isChecked();
    bool optionWO = findDialog->OptionWO->isChecked();
    
    if (searchString != "")
    { currTextEdit->findString(searchString, direction, optionCS, optionWO); }
}

void MainWindow::gotoLine()
{
    FileEdit *currTextEdit = (FileEdit*)TabWidget->currentPage();
    bool isNumber;
    int lineNo;
    if (LineNumber->text() != "")
    {
	lineNo = LineNumber->text().toInt( &isNumber, 10 ) - 1;
	if (lineNo < 0 || lineNo >= currTextEdit->lines())
	{ notice(tr("Goto Line"),QString(tr("Line number does not exist")), tr("OK"), "", "", ""); return; }
	if (isNumber)
	{
	    currTextEdit->setSelection(lineNo, 0, lineNo, currTextEdit->paragraphLength(lineNo));
	    currTextEdit->setCursorPosition(lineNo, 0);
	    currTextEdit->setFocus();
	}
    }
    LineNumberBox->hide();
    LineNumberButton->show();
    currTextEdit->setFocus();
}

void MainWindow::replace( QWidget * widget )
{
    FindDialog *dialog = (FindDialog *) widget;
    FileEdit *currTextEdit = (FileEdit*)TabWidget->currentPage();
    bool replaceAll =  dialog->AllReplace->isChecked();
    while (true)
    {
	find(dialog, true);
	if ( currTextEdit->hasSelectedText() )
	{
	    if (replaceAll)
	    {
		currTextEdit->removeSelectedText();
		currTextEdit->insert(dialog->ReplaceString->text());		
	    }
	    else
	    {
		bool response = notice(tr("Find and Replace"),QString(tr("Replace this selection?")), tr("Yes"), tr("No"), tr("Close"), "");
		// ToDo: Store Cursor Position and do not pass it for a second time 
		if (response  == QDialog::Accepted ) 
		{
		    currTextEdit->removeSelectedText();
		    currTextEdit->insert(dialog->ReplaceString->text());
		}
		else
		{
		    // Check "No" answer
		    if (response  != 3 ) 
			return;
		}
	    }
	}
	else
	{
	    return;
	}
    }
}

void MainWindow::closeFindDialog( QWidget * dialog)
{
    FileEdit *currTextEdit = (FileEdit*)TabWidget->currentPage();

    disconnect( dialog, SIGNAL( search(QWidget *, bool) ), this, SLOT( find(QWidget *, bool) ));
    disconnect( dialog, SIGNAL( replace(QWidget *) ), this, SLOT( replace(QWidget *) ));
    disconnect( dialog, SIGNAL( closed(QWidget *) ), this, SLOT( closeFindDialog(QWidget *) ));
    disconnect( this, SIGNAL( selectedText(QString) ), dialog, SLOT( setSearchText(QString) ));
    disconnect( this, SIGNAL( closed() ), dialog, SLOT( close() ));
    dialog->close();
    SearchButton->setEnabled(true);
    currTextEdit->setFocus();    
}

void MainWindow::closeFindBox()
{
    FileEdit *currTextEdit = (FileEdit*)TabWidget->currentPage();
    SearchBox->hide();
    SearchButton->show();
    currTextEdit->setFocus();
}

void MainWindow::tabChanged( QWidget * sender)
{
    int para, index;
    FileEdit *currtab = (FileEdit *)sender;
    currtab->getCursorPosition ( &para, &index );
    setLineNumber( para, index );
}

void MainWindow::setLineNumber( int para, int pos )
{
    QString parastr = QString::number(para+1);
    //pos = pos; //dummy
    
    if (para < 1000)
    {
	if (LineNumberButton->text() != parastr)
	    LineNumberButton->setText( parastr );
    }
    else
    {
	parastr.insert(parastr.length()-3, "\n");
	if (LineNumberButton->text() != parastr)
	    LineNumberButton->setText( parastr );
    }
}

void MainWindow::setSearchBoxText(QString text)
{
    FindString->setText(text.section("\n", 0, 0) );
}

void MainWindow::setModifiedTitle(bool m)
{
    // Set title to edited (e) or unedited
   FileEdit *currtab = (FileEdit *)TabWidget->currentPage();

     if (m)
    {
	if (currtab->equals(""))
	{ TabWidget->setTabLabel(currtab,tr( "new file")); }
	else
	{ TabWidget->setTabLabel(currtab, TabWidget->tabLabel(currtab) + " (e)"); }

    }
    else
    {	
	if (currtab->equals(""))
	{ TabWidget->setTabLabel(currtab, tr("empty")); }
	else // remove the (e) attachment
	{ TabWidget->setTabLabel(currtab, TabWidget->tabLabel(currtab).remove(TabWidget->tabLabel(currtab).length()-4, 4)); }
    }    
}


void MainWindow::editReplace()
{

}

void MainWindow::editGrep()
{

}


// ***************************************************
//   Repaint / Resize Functions
// ***************************************************


void MainWindow::update()
{

}


// ***************************************************
//   File operations
// ***************************************************

void MainWindow::Save( FileEdit * fileEdit )
{
    QFile file;
    
    // Check if file has been defined
    if (fileEdit->equals(""))
    {
	SaveAs(fileEdit);
    }
    else 
    {
	QFile file(fileEdit->getPath() );
	if ( !file.open( IO_WriteOnly ) )
	{
	    notice(tr("Save"),QString(tr("Path/file is Read-only, cannot \n save")+" \""+fileEdit->getFileName()+"\" "), tr("OK"), "", "", "");
	    return; 
	}
	else
	{
	    QTextStream ts( &file );
	    // ts.setEncoding(QTextStream::Latin1);
	    ts << fileEdit->text();
	    fileEdit->setUndoDepth(100);
	    fileEdit->setReadOnly(false);
	    fileEdit->setModified(false);
	    if ( fileEdit->getTab() < 0 )
	    {
		( (QWidget *) fileEdit->topLevelWidget())->setCaption( fileEdit->getFileName() );
	    }
	    else
	    {
		TabWidget->setTabLabel(fileEdit, fileEdit->getFileName());
	    }
	}
    }
}

void MainWindow::SaveAs( FileEdit * fileEdit )
{
    QString f = QFileDialog::getSaveFileName( fileEdit->getFileName(), tr("All Files (*);;C/C++ files (*.c *.cpp *.c++ *.gpp *.g++ *.h);;Web files (*.htm *.html);;Project file list (*.dir *.pro *.project)"), 0, tr("Save file(s)"));
    if ( !f.isEmpty())
    {
	if (QFile(f).exists())
	{
	    // Is it Read-only?
	    if ( !QFile(f).open( IO_WriteOnly ) )
	    {
		notice(tr("Save"),QString(tr("Path/file is Read-only, cannot \n save")+" \""+QFileInfo( f ).fileName()+"\" "), tr("OK"), "", "", "");
		fileSaveAs();
		return; 
	    }
	    // Is it Already Opened?
	    for ( FileEdit *tmpFileEdit = (FileEdit *)TabWidget->page(0); tmpFileEdit != NULL; tmpFileEdit=tmpFileEdit->getNext())
	    {
		if (tmpFileEdit->equals(QFileInfo( f ).filePath())) // && tmpFileEdit != fileEdit)
		{ 
		    notice(tr("Save"),QString(tr("File in use in another view, \ncannot use name")+" \""+QFileInfo( f ).fileName()+"\" "), tr("OK"), "", "", tr("Files can only be edited once, \nso you cannot choose a file that is edited in another window "));
		    fileSaveAs();
		    return; 
		}
	    }
	    // Does the file exist
	    if (notice(tr("Save"),QString(tr("File exists, overwrite?")+" \n\""+QFileInfo( f ).fileName()+"\" "), tr("Overwrite"), "", tr("Cancel"), "")  != QDialog::Accepted ) 
	    {
		return;
	    }
	}
	fileEdit->set( QFileInfo( f ).fileName(), QFileInfo( f ).filePath(), fileEdit->getTab() );
	Save(fileEdit);
	QFile(f).close();
    }
}


void MainWindow::saveProject()
{

}

void MainWindow::handleSelectedText( QString text )
{
    emit(selectedText(text));
}

void MainWindow::showSearchDialog( QWidget *fileEdit)
{
    FindDialog *dialog = new FindDialog(this);
    
    closeFindBox();
    dialog->show();
    SearchButton->setEnabled(false);
   
    if ( ((FileEdit *)fileEdit)->hasSelectedText() )
    { 
	dialog->SearchString->setText(((FileEdit *)fileEdit)->selectedText().section("\n", 0, 0) );
	// find(dialog); // Immediate search - better or worse?
    }
    
    connect( dialog, SIGNAL( search(QWidget *, bool) ), this, SLOT( find(QWidget *, bool) ));
    connect( dialog, SIGNAL( replace(QWidget *) ), this, SLOT( replace(QWidget *) ));
    connect( dialog, SIGNAL( closed(QWidget *) ), this, SLOT( closeFindDialog(QWidget *) ));
    connect( this, SIGNAL( selectedText(QString) ), dialog, SLOT( setSearchText(QString) ));
    connect( this, SIGNAL( closed() ), dialog, SLOT( close() ));
}


void MainWindow::resizeEvent( QResizeEvent * sizeEvent )
{
    GroupWidget->resize(sizeEvent->size().width(), sizeEvent->size().height()-180);
    TabWidget->resize(sizeEvent->size().width()-32, sizeEvent->size().height()-180);
    GroupWidgetProc->setGeometry(0, sizeEvent->size().height()-180, sizeEvent->size().width(), 120);
    StatusText->resize(sizeEvent->size().width()-160, 120);
}

void MainWindow::handleprocessFinished( int type, bool success )
{
    if (success) {}
    
    if (type == 1)
    {
	CompileButton->setEnabled(true);
    }
    else
    {
	RunXButton->setEnabled(true);
	RunButton->setEnabled(true);
    }
}



void MainWindow::configEdit()
{
    setupWin->show();
}


void MainWindow::askSave( FileEdit * fileedit )
{
    // Check modified editors
    if ( fileedit->isModified() )
    {
	// Show page
	if (fileedit->getTab() >= 0)
	{
	    TabWidget->setCurrentPage(fileedit->getTab());
	    TabWidget->showPage(TabWidget);
	}
	if (fileedit->getTab() < 0)
	{
	    ((QWidget *) fileedit->topLevelWidget())->setActiveWindow(); 
	    ((QWidget *) fileedit->topLevelWidget())->raise(); 
	}
	
	// Show save dialog
	if (fileedit->getFileName() != "")
	{
	    if ( notice(tr("File not saved"),tr("File") + " \"" + fileedit->getFileName() + "\"\n" + tr("has been modified, save?"), tr("Save"), tr("Don't save"), "", "") == QDialog::Accepted )
	    { Save( fileedit ); }
	}
	else
	{
	    if ( notice(tr("File not saved"),tr("Text has been modified, save?"), tr("Save"), tr("Don't save"), "", "") == QDialog::Accepted )
	    { Save( fileedit ); }
	}
    }
}
