#include <qdir.h>
#include "procview.h"

ProcView::ProcView(QWidget *parent, const char *name)
	: QTextEdit( parent, name )
{
    setReadOnly(true);
    init();
}


ProcView::~ProcView()
{

}

void ProcView::init()
{
    dir = new QDir;
    QString promptTxt;
    //StatusText->setText(url.user() + "@" + url.host() + ":" + dir.current() + "> \n");
    setText("USER@HOST" + dir->currentDirPath() + "> ");   
    
    process = new QProcess(this);
    connect( process, SIGNAL( readyReadStdout() ), this, SLOT( handleProcOutput() ) );
    connect( process, SIGNAL( processExited() ), this, SLOT( handleProcFinished() ) );
}
   
   
bool ProcView::run( QString arg )
{
    //topLevelWidget()->CompileButton->setEnabled(false);
    //( (QWidget *)parent() )->CompileButton->setEnabled(false);
    getEOF( &para, &pos );
    insertAt( arg + "\n", para, pos);    
    process->addArgument( arg );
    return process->start();
}

void ProcView::handleProcOutput()
{
    getEOF( &para, &pos );
    insertAt(process->readStdout(), para, pos);
}

void ProcView::getEOF( int *para, int *pos )
{
    *para=lines()-1;
    *pos=paragraphLength(*para);
}

void ProcView::handleProcFinished()
{
    getEOF( &para, &pos );
    insertAt("\nUSER@HOST" + dir->currentDirPath() + "> ", para, pos);   
    // (QWidget *)parent() )->CompileButton->setEnabled(true);
    if (process->normalExit() && process->exitStatus()==1)
    {
	emit (processFinished(1, true));
    }
    else
    {
	emit (processFinished(1, false));
    }	
}

