#include <qfile.h>
#include <stdio.h>
#include <qstring.h>
#include <qtextstream.h>
#include <qvaluelist.h> 
#include <qstringlist.h>
#include <qregexp.h>
#include "readconfig.h"  

#include <qtextedit.h>

ConfigItem::ConfigItem(QString _title, QString _content)
{
    title = _title;
    content = _content;
    subItem = NULL;
    nextItem = NULL;
};   

Setup::Setup()
{
    baseItem = NULL;
};   

bool Setup::readConfig(QString filename)
{
    // read Config file
    bool isReadOnly = false;
    if ( !QFile::exists( filename ) )
        return false;
    QFile file( filename );
    if ( !file.open( IO_ReadWrite ) )
    { 
	if ( !file.open( IO_ReadOnly ) )
 	{ return false; }
	else
	{ isReadOnly = true; }
     }
    QTextStream ts( &file );
    completText = ts.read().replace(QRegExp("\n"), "");
    file.close();
    return true; // EXIT_SUCCESS;
};

QString *Setup::separateConfig(QWidget *w)
{    // Vorher auf Korrektheit scannen (!)
    //QValueList<QStringList> configList;
    
    StringPairList *configList = new StringPairList();
    QStringList configPreList = QStringList::split('<', completText, true);
//int i= 0;
    if (configPreList.size() < 2)
        return new QString( w->tr("Resource file is not XML format") );
    QStringList::Iterator configIt = configPreList.begin();
    configIt++;
    for ( ; configIt != configPreList.end(); ++configIt )
    {
    //i++; if (i==1000) break;
        QStringList configPair = QStringList::split('>', *configIt, true);
	//text->insert(configPair.join("--"));
        if ( configPair.size() > 2)
            return new QString( w->tr("Tag sign \">\" not allowed in expression or  \"<\" missing\n ") + "<" + *configIt );
        if ( !configPair.first().startsWith("!--") )
        {
            if ( configPair.first().isEmpty() || configPair.first().compare("/")==0 || 
		 !(configPair.first().at(0)>='A' && configPair.first().at(0)<='Z' ||
		   configPair.first().at(0)>='a' && configPair.first().at(0)<='z' || configPair.first().at(0)=='/') )
                return new QString( w->tr("Invalid expression found\n") + "<" + *configIt );

            if ( configPair.size() > 1)
            {
                configPair.last().replace(QRegExp("&gt;"), ">");
                configPair.last().replace(QRegExp("&lt;"), "<");
            }
            configList->append(configPair);
       }
   }

    baseItem = new ConfigItem("", "");
//    baseItem = new ConfigItem(configList->first().first(), configList->first().last());
//    configList->pop_front();
    QString *errStr = itemizeConfig(w, baseItem, configList);
//    configList->pop_front();
    return errStr;
};
   
QString *Setup::itemizeConfig(QWidget *w, ConfigItem *item, StringPairList *configList)
{
    // Create Subitem
    QString *errorStr = new QString();
    
    if ( configList->empty() )
        return errorStr;
   
    // Create subitems
    if ( configList->first().first().at(0) != QChar('/'))
    {
        ConfigItem *newItem = new ConfigItem(configList->first().first(), configList->first().last());
        configList->pop_front();
        item->subItem = newItem;
        item = newItem;
    }
    else
        return errorStr;

    if ( configList->first().first().at(0) != QChar('/') )
        errorStr=itemizeConfig(w, item, configList);	
    if ( !errorStr->isEmpty() )
        return errorStr;

    //if ( configList->first().first().at(0) == QChar('/') )
    //{
        if ( configList->first().first() ==  "/" + QStringList::split(' ', item->title, true).first() )
            configList->pop_front();
        else
            return new QString( w->tr("Expected end-of-tag for ") + "\"<" + item->title + ">\"\n" + w->tr("not found in expression") 
            + " \"<" + configList->first().first() + ">\"");
    //}    
    
    // Create next Items
    while ( !configList->empty() && configList->first().first().at(0) != QChar('/') )
    {
        ConfigItem *newItem = new ConfigItem(configList->first().first(), configList->first().last());
        configList->pop_front();
        item->nextItem = newItem;
        item = newItem;

        if ( configList->first().first().at(0) != QChar('/') )
            errorStr=itemizeConfig(w, item, configList);	
        if ( !errorStr->isEmpty() )
            return errorStr;

        //if ( configList->first().first().at(0) == QChar('/') )
        //{
            if ( configList->first().first() ==  "/" + QStringList::split(' ', item->title, true).first() )
                configList->pop_front();
            else
            {
                return new QString( w->tr("Expected end-of-tag for ") + "\"<" + item->title + ">\"\n" + w->tr("not found in expression") 
                + " \"<" + configList->first().first() + ">\"");
            }
        //}
    }

    return errorStr;
};
