/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename slots use Qt Designer which will
** update this file, preserving your code. Create an init() slot in place of
** a constructor, and a destroy() slot in place of a destructor.
*****************************************************************************/

void SetupWindow::init()
{
    //QColor grey1 = QColor(224, 224, 224);
    //ChooseConfig->setPaletteBackgroundColor ( grey1 );
    for (int i=0; i<4; i++)
    {
        colors[i] = QColor( 200, 200, 200 );
    }
    
    ChooseConfig->insertItem( tr("none") );
    setup = new Setup();
    fontDB = new QFontDatabase();
    fontSize = 10;
    layoutNo=0;
    groupName = NULL;

    fontFoundries = fontDB->families();
    ChooseFoundry->insertStringList( fontFoundries );
    ChooseFoundry->resize(ChooseFoundry->sizeHint());
    ChooseFoundry_2->insertStringList( fontFoundries );
    ChooseFoundry_2->resize(ChooseFoundry_2->sizeHint());
    
    // Create a list for widgets?
    // QValueList<QWidget>
}

QString *SetupWindow::readConfigFile( QString filename )
{
    if ( !setup->readConfig(filename) )
        return new QString( tr("File") + " \"" + filename +  "\" " + tr("does not exist") );
    QString *errorStr;
    errorStr = setup->separateConfig(this);
    if ( !errorStr->isEmpty() )
         return errorStr;

    return new QString();    
}

void SetupWindow::readItem( ConfigItem *item, const char * title, QLineEdit *target)
{
    if (item->title.compare(title) == 0)
        target->setText(item->content);
}

void SetupWindow::readMLItem( ConfigItem *item, const char * title, QTextEdit *target)
{
    if (item->title.compare(title) == 0)
        target->setText(item->content);
}

ConfigItem *SetupWindow::addItem( ConfigItem *item, const char * title, QLineEdit *target)
{
    if (target->text().compare("") != 0)
    {
        item->nextItem = new ConfigItem(title, target->text());
        return item->nextItem;
    }
    else
   {
       return item;
   }
 }

ConfigItem *SetupWindow::addMLItem( ConfigItem *item, const char * title, QTextEdit *target)
{
    if (target->text().compare("") != 0)
    {
        item->nextItem = new ConfigItem(title, target->text());
        return item->nextItem;
    }
    else
   {
       return item;
   }
}

void SetupWindow::readTabRow( ConfigItem *item, const char * title, QTable *target, int row)
{
    QStringList strList;
    
    if (item->title.compare(title) == 0)
    {
        strList = QStringList::split(',', item->content, true);
        if ( strList.size() == 3)
        {
            int col=0;
            for ( QStringList::Iterator it = strList.begin(); it != strList.end(); ++it, col++ )
                target->setText(row, col, *it);
        }
    }
}

ConfigItem *SetupWindow::addTabRow( ConfigItem *item, const char * title, QTable *target, int row)
{
    QStringList strList;

    item->nextItem = new ConfigItem(title, target->text(row, 0) + "," + target->text(row, 1) + "," + target->text(row, 2));
    return item->nextItem;
}


ConfigItem *SetupWindow::findItem( const int tabNo, ConfigItem *listItem, int selNo)
{
    bool isGroup = false;
    ConfigItem *parentItem = NULL;
    
    switch ( tabNo )
    {
    case 0:
        procNo = 0;
        if (groupName != NULL)
        {
            if (selNo==0)
            {
                delete (groupName);
                groupName = NULL;
            }
            else
            {
                procNo++;
            }
        }
	    
        while (listItem!=NULL && procNo<=selNo)
        {
//qDebug( "--search process--");
            if (listItem->title == "process" && (groupName==NULL || isGroup==true))
            {	
                if (procNo == selNo)
                {
//qDebug( "--found process--");
                    TabWidget3->setEnabled(true);

                    /*ConfigItem *tmplistItem = listItem->subItem;
                    while (tmplistItem!=NULL)
                    {
                        if (tmplistItem->title.compare("label") == 0)
                        {
                            Title->setText(tmplistItem->content);
                            break;
                        }
                        tmplistItem = tmplistItem->subItem;
                    }*/
		
                    Title->setText(tr("Processor"));
                    return listItem;
                }
                procNo++;
            }
	    
            if ( listItem->title == "processgroup")
            {
//qDebug( "--found group--");
                if (procNo == selNo && groupName==NULL)
                {
                    TabWidget3->setEnabled(false);
                    Title->setText(tr("Group"));
                    groupName = new QString(listItem->subItem->content);
                    procNo = 1;
                    printNo = 0;
                    return listItem;
                }
		 
                if (groupName!=NULL && listItem->subItem!=NULL)
                {
//qDebug( "--grname-- %s", QString(listItem->subItem->content).latin1());
//qDebug( " %d %d", procNo ,  selNo);
                    if (listItem->subItem->content.compare(*groupName) == 0)
                    {
//qDebug( "--- is ---");
                        if (procNo == selNo)
                        {
                            TabWidget3->setEnabled(false);
                            Title->setText(tr("Group"));
                            return listItem;
                        }
                        else
                        {
                            parentItem = listItem;
                            listItem = listItem->subItem;
                            isGroup = true;
                            procNo++;
                        }
//qDebug( "--- %d ---", procNo);
                    }
                }
                else
                {
                    procNo++;
                }
            }
	    
            if (listItem== NULL && isGroup)
            {
                listItem = parentItem; //->nextItem;
                isGroup = false;
            }
            listItem = listItem->nextItem;
//qDebug( "end");
        }
        break;

    case 1:
        printNo = 0;
        while (listItem!=NULL && printNo<=selNo)
        {
            if (listItem->title == "printer")
            {
                if ( printNo == selNo)
                {
                    return listItem;
                }
                printNo++;
            }
            listItem = listItem->nextItem;
        }	
        break;
	
    case 2:
        layoutNo = 0;
        while (listItem!=NULL && layoutNo<=selNo)
        {
            if (listItem->title == "layout")
            {
                if ( layoutNo == selNo)
                {
                    return listItem;
                }
                layoutNo++;
            }
            listItem = listItem->nextItem;
        }		
        break;
	
    default:
        break;	
    }
	
    return NULL;
}

void SetupWindow::ChooseConfig_activated( int selNo )
{
    ConfigItem *listItem = NULL;
    QStringList strList;

    if (setup->baseItem == NULL  ||  setup->baseItem->subItem==NULL)
        return;
    
    switch ( TabWidget3->currentPageIndex() )
    {
    case 0:
	
        Conftitle->clear();
        Priority->clear();
        ConfSourceCall->clear();
        ConfSourceExtension->clear();
        ErrorMessageFormat->clear();
        ConfTargetExtension->clear();
        ConfTargetCall->clear();
        SetPrinter->clear();
	
        listItem = setup->baseItem->subItem;
//qDebug( "--finditem--");
        listItem = findItem(0, listItem, selNo);
        listItem=listItem->subItem;

        while (listItem!=NULL)
        {
//qDebug( "--found %s--", QString(listItem->content).latin1());
            readItem( listItem, "title", Conftitle );
            readItem( listItem, "priority", Priority );
            readItem( listItem, "compile", ConfSourceCall );
            readItem( listItem, "suffix", ConfSourceExtension );
            readItem( listItem, "errormsg", ErrorMessageFormat );
            readItem( listItem, "postfix", ConfTargetExtension );
            readItem( listItem, "run", ConfTargetCall );

            if (listItem->title.compare("terminates") == 0)
            {
                CompilerTerminates->setChecked(  !(listItem->content.compare("false") == 0 ) );
            }
			
            if (listItem->title.compare("nosave") == 0)
            {
                DisableWhileProcessing->setChecked( !(listItem->content.compare("false") == 0 ) );
            }
	    
            // Set Printer defined for Processor
            if (listItem->title.compare("useprinter") == 0)
            {
                printNo = listItem->content.toInt();
            }

            listItem = listItem->nextItem;
        }
			
        // Add Printer list
        listItem = setup->baseItem->subItem;
        //listItem = findItem(0, listItem, selNo);
        //listItem=listItem->subItem;
        while (listItem!=NULL)
        {
            if ( listItem->title == "printer" )
            {
                if (listItem->subItem != NULL)
                    SetPrinter->insertItem(listItem->subItem->content);
                if (listItem->subItem->nextItem != NULL && listItem->subItem->nextItem->content.toInt()==printNo)
                    SetPrinter->setCurrentItem(printNo);
            }
            listItem = listItem->nextItem;
        }
	
        //Create new Setup list
        listItem = setup->baseItem->subItem;
        ChooseConfig->clear();

        if (groupName!=NULL)
        {
            ChooseConfig->insertItem("-- " + tr("top") + " --");
        }
	
        while (listItem!=NULL && listItem->title != NULL)
        {
            if ( listItem->title == "processgroup" )
            {
//qDebug( "--groupname %s--", QString(listItem->subItem->content).latin1());
                if (listItem->subItem != NULL && groupName==NULL)
	    ChooseConfig->insertItem(listItem->subItem->content + " (" + tr("Group") + ")");
                if (groupName!=NULL && listItem->subItem->content.compare(*groupName) == 0)
                {
//qDebug( "--groupaktu %s--", QString(*groupName).latin1());
	    ChooseConfig->insertItem(listItem->subItem->content + " (" + tr("Group") + ")");
                    ConfigItem *sublistItem = listItem->subItem;
                    while (sublistItem!=NULL && sublistItem->title != NULL)
                    {
                        if ( sublistItem->title == "process" )
                        {
//qDebug( "--process %s--", QString(listItem->subItem->content).latin1());
                            if (sublistItem->subItem != NULL)
                                ChooseConfig->insertItem(listItem->subItem->content + " / " + sublistItem->subItem->content);
                        }
                        sublistItem = sublistItem->nextItem;
                    }
                }
            }
	    
            if ( listItem->title == "process" && groupName==NULL)
            {
                if (listItem->subItem != NULL)
                    ChooseConfig->insertItem(listItem->subItem->content);
            }
	    
            listItem = listItem->nextItem;
        }
        ChooseConfig->setCurrentItem(procNo);
	
        break;

    case 1:    
        Conftitle->clear();
        Priority->clear();
        PrintDevice->clear();
        PrintFormat->clear();
        PrintOdd->clear();
        PrintEven->clear();
        PrintAgain->clear();
	    
        listItem = setup->baseItem->subItem;
        listItem = findItem(1, listItem, selNo);
        listItem=listItem->subItem;
	
        while (listItem!=NULL)
        {
            readItem( listItem, "title", Conftitle );
            readItem( listItem, "priority", Priority );
            readItem( listItem, "device", PrintDevice );
            readMLItem( listItem, "formatted", PrintFormat );
            readMLItem( listItem, "formatted_odd", PrintOdd );
            readMLItem( listItem, "formatted_even", PrintEven );
            readMLItem( listItem, "preformatted", PrintAgain );

            listItem = listItem->nextItem;
        }

        break;

    case 2:
        Conftitle->clear();
        Priority->clear();
        MainWinSize->clear();
        SubWinSize->clear();

        listItem = setup->baseItem->subItem;
        listItem = findItem(2, listItem, selNo);
        listItem=listItem->subItem;
	
        while (listItem!=NULL)
        {
            readItem( listItem, "title", Conftitle );
            readItem( listItem, "priority", Priority );
            readItem( listItem, "main_window_size", MainWinSize );
            readItem( listItem, "sub_window_size", SubWinSize );

            if (listItem->title.compare("main_window_font") == 0)
            {
                strList = QStringList::split('-', listItem->content, true);
                fontSize = strList.last().toInt();
                ChooseFoundry_activated( strList.first() );
//qDebug( "-- Foundry %s--", strList.first().latin1());

                if ( strList.size() > 1)
                {
                    FontExample->setFont( QFont( strList.first(), strList.last().toInt() ) );
                }
                //SubWinSize->setText(listItem->content);
            }		
            if (listItem->title.compare("sub_window_font") == 0)
            {
                strList = QStringList::split('-', listItem->content, true);
                subfontSize = strList.last().toInt();
                ChooseFoundry_2_activated( strList.first()  );
 				    
                if ( strList.size() > 1)
                {
                    FontExample_2->setFont( QFont( strList.first(), strList.last().toInt() ) );
                }
                 //SubWinSize->setText(listItem->content);
            }
            readTabRow( listItem, "font_color", ColorTable, 0);
            readTabRow( listItem, "bg_color", ColorTable, 1);
            readTabRow( listItem, "menu_color", ColorTable, 2);
            readTabRow( listItem, "button_color", ColorTable, 3);
	    
            listItem = listItem->nextItem;
        }

	
    default:
       break;
    }    
}

void SetupWindow::ChooseFoundry_target( const QString & foundry, QComboBox *sizesTarget, QComboBox *stylesTarget, QString & newFoundry, int &size, QLabel * example)
{
    QStringList fontStyles = fontDB->styles(foundry);
    QValueList<int> fontSizes = fontDB->pointSizes(foundry);
    QStringList fontSizesStr;
    stylesTarget->clear();
    sizesTarget->clear();
    stylesTarget->insertStringList(fontStyles);
    QString s;
    int newFontSize = 0;
    int fontIndex = -1;
    for ( QValueList<int>::Iterator fontIt = fontSizes.begin(); fontIt != fontSizes.end(); ++fontIt ) 
    {
        s = s.sprintf("%d", *fontIt);
        fontSizesStr.append( s );
        if (*fontIt <= size  || newFontSize==0)
        {
            fontIndex++;
            newFontSize = *fontIt;
        }
    }
    size = newFontSize;
    sizesTarget->insertStringList(fontSizesStr);
    sizesTarget->setCurrentItem(fontIndex);
    example->setFont( QFont(foundry, fontSize) );
    newFoundry = foundry;
  
    // If activated passively, item has to be selected afterwards
    if (foundry != ChooseFoundry->currentText ())
    {
        int foundryIndex = 0;
        for ( QStringList::Iterator foundryIt = fontFoundries.begin(); foundryIt != fontFoundries.end(); ++foundryIt ) 
        {
            if ((*foundryIt).lower() ==  foundry.lower())
            {
                ChooseFoundry->setCurrentItem(foundryIndex);
                return;
            }
            // Deal with font names containing "[ ]"
//qDebug( "-- Foundry 1 (%s) Foundry 2 (%s)--",foundry.latin1(), QStringList::split('[', *foundryIt).first().latin1());
            if ( QStringList::split('[', foundry).size() == 1
                && (foundry.lower() == QStringList::split('[', (*foundryIt).lower()).first()
                || foundry.lower() == QStringList::split(" [", (*foundryIt).lower()).first() ) )
            {
                ChooseFoundry->setCurrentItem(foundryIndex);
                return;
            }
            foundryIndex++;
        }
    }

}

void SetupWindow::ChooseFoundry_activated( const QString & foundry)
{
    ChooseFoundry_target(foundry, ChooseSize, ChooseStyle, fontFoundry, fontSize, FontExample);
}

void SetupWindow::ChooseFoundry_2_activated( const QString & foundry)
{
    ChooseFoundry_target(foundry, ChooseSize_2, ChooseStyle_2, subfontFoundry, subfontSize, FontExample_2);
}


void SetupWindow::ChooseStyle_activated( const QString & style)
{
    //FontExample.setFont( QFont(fontFoundry, fontSizes.first) );
}

void SetupWindow::ChooseStyle_2_activated( const QString & style)
{
    //FontExample.setFont( QFont(fontFoundry, fontSizes.first) );
}


void SetupWindow::ChooseSize_activated( const QString & size)
{
    fontSize = size.toInt();
    FontExample->setFont( QFont(fontFoundry, fontSize) );
}

void SetupWindow::ChooseSize_2_activated( const QString & size)
{
    subfontSize = size.toInt();
    FontExample_2->setFont( QFont(subfontFoundry, subfontSize) );
}


void SetupWindow::TabWidget3_currentChanged( QWidget * w)
{
    if (setup == NULL)
        return;
    if (setup->baseItem == NULL)
        return;
    if (setup->baseItem->subItem == NULL)
        return;
    
    ConfigItem *listItem = NULL;
    
    TextLabel4->setEnabled(true);
    Title->setEnabled(true);
    Title2->setEnabled(true);
    Title3->setEnabled(true);
    ChooseConfig->setEnabled(true);
    Add->setEnabled(true);
    Conftitle->setEnabled(true);   
    Priority->setEnabled(true);
    SaveValues->setEnabled(true);
    Update->setEnabled(true);
   
    switch ( TabWidget3->currentPageIndex() )
    {
    case 0:
        Title->setText( tr("Processor") );
        Title2->setText( tr("Processor") );
	
        ChooseConfig_activated( procNo );
        break;

    case 1:
        Title->setText( tr("Printformat") );
        Title2->setText( tr("Printformat") );
        ChooseConfig->clear();

        listItem = setup->baseItem->subItem;
        while (listItem!=NULL)
        {
            if ( listItem->title == "printer" )
            {
                if (listItem->subItem != NULL)
                    ChooseConfig->insertItem(listItem->subItem->content);
            }
            listItem = listItem->nextItem;
        }
        ChooseConfig->setCurrentItem(printNo);
        ChooseConfig_activated( printNo );
        break;

    case 2:
        Title->setText( tr("Layout") );
        Title2->setText( tr("Layout") );
        ChooseConfig->clear();

        listItem = setup->baseItem->subItem;
        while (listItem!=NULL)
        {
            if ( listItem->title == "layout" )
            {
                if (listItem->subItem != NULL)
                    ChooseConfig->insertItem(listItem->subItem->content);
            }
            listItem = listItem->nextItem;
        }
        ChooseConfig->setCurrentItem(layoutNo);
        ChooseConfig_activated( layoutNo );
        break;

    default:
        TextLabel4->setEnabled(false);
        Title->setEnabled(false);
        Title2->setEnabled(false);
        Title3->setEnabled(false);
        ChooseConfig->setEnabled(false);
        Add->setEnabled(false);
        Conftitle->setEnabled(false);
        Priority->setEnabled(false);
        SaveValues->setEnabled(false);
        Update->setEnabled(false);
        break;
    }
}

void SetupWindow::checkGeometry1(const QString & content)
{
    QStringList strList = QStringList::split('x', content, true);
    if (strList.size() !=2  || strList.first().toInt()<=0 || strList.last().toInt()<=0)
    MainWinSize->setText("");
}

void SetupWindow::checkGeometry2(const QString & content)
{
    QStringList strList = QStringList::split('x', content, true);
    if (strList.size() !=2  || strList.first().toInt()<=0 || strList.last().toInt()<=0)
    SubWinSize->setText("");
}

void SetupWindow::Update_pressed()
{
    ConfigItem *listItem = NULL;
    QStringList strList;
    QString numberstr;

    if (setup->baseItem == NULL  ||  setup->baseItem->subItem==NULL)
        return;

    
    switch ( TabWidget3->currentPageIndex() )
    {
    case 0:
        listItem = setup->baseItem->subItem;
        listItem = findItem(0, listItem, procNo);

        if ( listItem->title == "processgroup")
        {
            listItem->subItem->content = QString(Conftitle->text());
            return;
        }
	
        // Delete entry values
        while (listItem->subItem !=NULL)
        {
            ConfigItem *tmplistItem=listItem->subItem->nextItem;
            delete listItem->subItem;
            listItem->subItem = tmplistItem;
        }
	
        // Create new entry, left out empty values 
        listItem->subItem = new ConfigItem("title", Conftitle->text());
        listItem=listItem->subItem;
        listItem = addItem( listItem, "priority", Priority );
        listItem = addItem( listItem, "compile", ConfSourceCall );
        listItem = addItem( listItem, "suffix", ConfSourceExtension );
        listItem = addItem( listItem, "errormsg", ErrorMessageFormat );
        listItem = addItem( listItem, "postfix", ConfTargetExtension );
        listItem = addItem( listItem, "run", ConfTargetCall );
        if (!CompilerTerminates->isChecked())
        {
            listItem->nextItem = new ConfigItem("terminates", "false");
            listItem=listItem->nextItem;
        }
       if (!DisableWhileProcessing->isChecked())
        {
            listItem->nextItem = new ConfigItem("nosave", "false");
            listItem=listItem->nextItem;
        }
        printNo = SetPrinter->currentItem();
        numberstr = QString::number( printNo );
        listItem->nextItem = new ConfigItem("useprinter", numberstr);     
        break;

    case 1:
        listItem = setup->baseItem->subItem;
        listItem = findItem(1, listItem, printNo);
	
	
        // Delete entry values
        while (listItem->subItem !=NULL)
        {
            ConfigItem *tmplistItem=listItem->subItem->nextItem;
            delete listItem->subItem;
            listItem->subItem = tmplistItem;
        }
	
        // Create new entry, left out empty values 
        listItem->subItem = new ConfigItem("title", Conftitle->text());
        listItem=listItem->subItem;
        numberstr = QString::number( printNo );
        listItem->nextItem = new ConfigItem("number", numberstr);     
        listItem=listItem->nextItem;
        listItem = addItem( listItem, "priority", Priority );
        listItem = addItem( listItem, "device", PrintDevice );
        listItem = addMLItem( listItem, "formatted", PrintFormat );
        listItem = addMLItem( listItem, "formatted_odd", PrintOdd );
        listItem = addMLItem( listItem, "formatted_even", PrintEven );
        listItem = addMLItem( listItem, "preformatted", PrintAgain );

        break;

    case 2:
        listItem = setup->baseItem->subItem;
        listItem = findItem(2, listItem, layoutNo);
	
        // Delete entry values
        while (listItem->subItem !=NULL)
        {
            ConfigItem *tmplistItem=listItem->subItem->nextItem;
            delete listItem->subItem;
            listItem->subItem = tmplistItem;
        }
	
        // Create new entry, left out empty values 
        listItem->subItem = new ConfigItem("title", Conftitle->text());
        listItem=listItem->subItem;
        listItem = addItem( listItem, "priority", Priority );
        listItem = addItem( listItem, "main_window_size", MainWinSize );
        listItem = addItem( listItem, "sub_window_size", SubWinSize );
        listItem->nextItem = new ConfigItem( "main_window_font", 
            ChooseFoundry->currentText() + "-" + 
            ChooseStyle->currentText() + "-" + 
            ChooseSize->currentText() );
        listItem=listItem->nextItem;
        listItem->nextItem = new ConfigItem( "sub_window_font", 
            ChooseFoundry_2->currentText() + "-" + 
            ChooseStyle_2->currentText() + "-" + 
            ChooseSize_2->currentText() );
        listItem = listItem->nextItem;
        listItem = addTabRow( listItem, "font_color", ColorTable, 0);
        listItem = addTabRow( listItem, "bg_color", ColorTable, 1);
        listItem = addTabRow( listItem, "menu_color", ColorTable, 2);
        listItem = addTabRow( listItem, "button_color", ColorTable, 3);
	
                    setFont( QFont( ChooseFoundry->currentText(), ChooseSize->currentText().toInt() ) );
	//setPaletteBackgroundColor( QColor( ColorTable->text(0, 0), ColorTable->text(0, 1), ColorTable->text(0, 2),  )  );
	setPaletteBackgroundColor( QColor( ColorTable->text(1, 0).toInt(), ColorTable->text(1, 1).toInt(), ColorTable->text(1, 2).toInt()  )  );
	//setPaletteBackgroundColor( QColor( ColorTable->text(2, 0), ColorTable->text(2, 1), ColorTable->text(2, 2),  )  );
	ChooseConfig->setPaletteBackgroundColor( QColor( ColorTable->text(3, 0).toInt(), ColorTable->text(3, 1).toInt(), ColorTable->text(3, 2).toInt()  )  );
    for (int i=0; i<4; i++)
    {
        colors[i] = QColor( ColorTable->text(i, 0).toInt(), ColorTable->text(i, 1).toInt(), ColorTable->text(i, 2).toInt() );
    }
        break;

    default:

	
       break;
    }
    
    TabWidget3_currentChanged( TabWidget3 );
}

void SetupWindow::setColorValue( int value)
{
    QString numberstr;
    numberstr = QString::number(-value);
    ColorTable->setText(ColorTable->currentRow(), ColorTable->currentColumn(),  numberstr);
}

QColor SetupWindow::getColor(int colorNo)
{
    return colors[colorNo];
}

void SetupWindow::setSliderValue( int row, int col)
{
    ColorSlider->setValue(-ColorTable->text(row, col).toInt());
}

void SetupWindow::Cancel_pressed()
{
    close();
}

void SetupWindow::Reset_pressed()
{
    TabWidget3_currentChanged( TabWidget3 );
}


void SetupWindow::saveSetup()
{
    close();
}




void SetupWindow::newSlot()
{

}
