/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename slots use Qt Designer which will
** update this file, preserving your code. Create an init() slot in place of
** a constructor, and a destroy() slot in place of a destructor.
*****************************************************************************/
//#include <qfiledialog.h>
#include <qcheckbox.h>
#include <qradiobutton.h>
#include ".ui/notice.h"
#include ".ui/inputdialog.h"
#include ".ui/mainwindow.h"
#include ".ui/finddialog.h"
// #include "configfile.h"


// ***************************************************
//   Class functions
// ***************************************************

void SubWindow::init()
{
    // Update geometry of tools
    TextLabel1->resize(TextLabel1->sizeHint());
    LineNumberBox->resize(LineNumberBox->sizeHint().width()+4, LineNumberBox->height());
    LineNumberBox->hide();
    TextLabel1_2->resize(TextLabel1_2->sizeHint());
    SearchBox->resize(SearchBox->sizeHint().width()+4, SearchBox->height());
    SearchBox->hide();
}  

void SubWindow::destroy()
{
}

// ***************************************************
//   Menu functions
// ***************************************************

void SubWindow::fileSave()
{
    //SubTextEdit->save();
    emit(saved(SubTextEdit));
}

void SubWindow::editIntern()
{
    //SubTextEdit->minimize();
    emit(minimized((QWidget *) this));
}

void SubWindow::editFind()
{
    showSearchDialog(SubTextEdit);
}

void SubWindow::editCut()
{
    if (SubTextEdit->hasSelectedText())
    { SubTextEdit->cut(); }
}

void SubWindow::editCopy()
{
    if (SubTextEdit->hasSelectedText())
    { SubTextEdit->copy(); }
}

void SubWindow::editPaste()
{
    SubTextEdit->paste();
}


void SubWindow::editRedo()
{
    SubTextEdit->redo();
}

void SubWindow::editUndo()
{
    SubTextEdit->undo();
}

void SubWindow::editGotoLine()
{
    LineNumberButton->hide();
    LineNumberBox->raise();
    LineNumberBox->show();
    LineNumber->setFocus();
    LineNumber->setText("");
}

void SubWindow::fileExit()
{
    SubTextEdit->close();
    emit(closed( (QWidget *) this ));
}


// ***************************************************
//   Popup / Extern Window functions
// ***************************************************

int SubWindow::inputDialog( const char * caption, const char * title, const char * acceptText, const char *input, const char * helpmessage )
{
    InputDialog *dialog = new InputDialog(this); 
   
     dialog->setLabels(title, acceptText, input, helpmessage);
     dialog->setCaption( caption  );
     return dialog->exec();
}


int SubWindow::notice( const char * caption, const char * title, const char * acceptText, const char * refuseText, const char * cancelText, const char * helpmessage )
{
    NoticeWindow *notice = new NoticeWindow(this, "",WStyle_Customize | WStyle_DialogBorder | WStyle_Title); 
    
    QStringList messagelist = QStringList::split("\n", helpmessage);
    while (messagelist.count() < 3)
    { messagelist.append(""); }
    notice->setLabels(title, acceptText, refuseText, cancelText, messagelist[0], messagelist[1] );
    notice->setCaption( caption );
    int result = notice->exec();
    notice->set_size();
    return result;
}


// ***************************************************
//   Behavior / Action functions
// ***************************************************

void SubWindow::setModifiedTitle(bool m)
{
    // Set title for tab depending on whether text was edited or un-edited
    if (m) //( SubTextEdit->isModified() )
    {
	if (SubTextEdit->equals(""))
	{ setCaption("new file"); }
	else
	{ setCaption(caption() + " (e)"); }
    }
    else
    {	
	if (SubTextEdit->equals(""))
	{ setCaption("empty"); }
	else
	{ setCaption(caption().remove(caption().length()-4, 4)); }
    }
}


void SubWindow::findNext()
{
    QString searchString = QString(FindString->text());
  
    if (searchString != "")
    { SubTextEdit->findString(searchString, true, false, false); }
}

void SubWindow::findPrev()
{
    QString searchString = QString(FindString->text());
    
    if (searchString != "")
    { SubTextEdit->findString(searchString, false, false, false); }
}

void SubWindow::showSearchDialog( QWidget * fileEdit)
{
    FindDialog *dialog = new FindDialog(this);
    
    closeFindBox();
    dialog->show();
    SearchButton->setEnabled(false);
   
    if ( ((FileEdit *)fileEdit)->hasSelectedText() )
    { 
	dialog->SearchString->setText(((FileEdit *)fileEdit)->selectedText().section("\n", 0, 0) );
	// find(dialog); // Immediate search - better or worse?
    }
    
    connect( dialog, SIGNAL( search(QWidget *, bool) ), this, SLOT( find(QWidget *, bool) ));
    connect( dialog, SIGNAL( replace(QWidget *) ), this, SLOT( replace(QWidget *) ));
    connect( dialog, SIGNAL( closed(QWidget *) ), this, SLOT( closeFindDialog(QWidget *) ));
    connect( this, SIGNAL( selectedText(QString) ), dialog, SLOT( setSearchText(QString) ));
    connect( this, SIGNAL( closed(QWidget*) ), dialog, SLOT( close() ));
}


void SubWindow::gotoLine()
{
    bool isNumber;
    int lineNo;
    
    if (LineNumber->text() != "")
    {
	lineNo = LineNumber->text().toInt( &isNumber, 10 ) - 1;
	if (lineNo < 0 || lineNo >= SubTextEdit->lines())
	{ notice("Goto Line",QString(tr("Line number does not exist")), tr("OK"), "", "", ""); return; }
	if (isNumber)
	{
	    SubTextEdit->setSelection(lineNo, 0, lineNo, SubTextEdit->paragraphLength(lineNo));
	    SubTextEdit->setCursorPosition(lineNo, 0);
	    SubTextEdit->setFocus();
	}
    }
    LineNumberBox->hide();
    LineNumberButton->show();
    LineNumberButton->raise();
   SubTextEdit->setFocus();
}

void SubWindow::editFindShort()
{
    SearchButton->hide();
    SearchBox->show();
    SearchBox->raise();
    FindString->setFocus();
	
    if (SubTextEdit->hasSelectedText())
    { 
	FindString->setText(SubTextEdit->selectedText().section("\n", 0, 0) );
    }
    else
    { 
	FindString->setText("");
    }
}


void SubWindow::setLineNumber( int para, int pos )
{

    QString parastr = QString::number(para+1);
    pos = pos; //dummy
    
    if (para < 1000)
    {
	if (LineNumberButton->text() != parastr)
	    LineNumberButton->setText( parastr );
    }
    else
    {
	parastr.insert(parastr.length()-3, "\n");
	if (LineNumberButton->text() != parastr)
	    LineNumberButton->setText( parastr );
    }
}


void SubWindow::setSearchBoxText(QString text)
{
    FindString->setText(text.section("\n", 0, 0) );
}

void SubWindow::find( QWidget * widget, bool direction )
{
    FindDialog *findDialog = (FindDialog *) widget;

    // Get selected options
    QString searchString = QString(findDialog->SearchString->text());
    bool optionCS =  findDialog->OptionCS->isChecked();
    bool optionWO = findDialog->OptionWO->isChecked();
    
    if (searchString != "")
    { SubTextEdit->findString(searchString, direction, optionCS, optionWO); }
}

void SubWindow::replace(QWidget * widget)
{
    FindDialog *dialog = (FindDialog *) widget;
    bool replaceAll =  dialog->AllReplace->isChecked();
    
    while (true)
    {
	find(dialog, true);
	if ( SubTextEdit->hasSelectedText() )
	{
	    if (replaceAll)
	    {
		SubTextEdit->removeSelectedText();
		SubTextEdit->insert(dialog->ReplaceString->text());		
	    }
	    else
	    {
		bool response = notice(tr("Find and Replace"),QString(tr("Replace this selection?")), tr("Yes"), tr("No"), tr("Close"), "");
		// ToDo: Store Cursor Position and do not pass it for a second time 
		if (response  == QDialog::Accepted ) 
		{
		    SubTextEdit->removeSelectedText();
		    SubTextEdit->insert(dialog->ReplaceString->text());
		}
		else
		{
		    // Check "No" answer
		    return;
		}
	    }
	}
	else
	{
	    return;
	}
    }
}


void SubWindow::closeFindDialog( QWidget * dialog )
{
    disconnect( dialog, SIGNAL( search(QWidget *, bool) ), this, SLOT( find(QWidget *, bool) ));
    disconnect( dialog, SIGNAL( replace(QWidget *) ), this, SLOT( replace(QWidget *) ));
    disconnect( dialog, SIGNAL( closed(QWidget *) ), this, SLOT( closeFindDialog(QWidget *) ));
    disconnect( this, SIGNAL( selectedText(QString) ), dialog, SLOT( setSearchText(QString) ));
    disconnect( this, SIGNAL( closed(QWidget*) ), dialog, SLOT( close() ));
    dialog->close();
    SearchButton->setEnabled(true);
    SubTextEdit->setFocus();
}


void SubWindow::closeFindBox()
{
    SearchBox->hide();
    SearchButton->show();
    SubTextEdit->setFocus();
}


void SubWindow::handleSelectedText( QString text )
{
    emit(selectedText(text));
}

void SubWindow::resizeEvent( QResizeEvent * sizeEvent )
{
    GroupWidget->resize(sizeEvent->size().width(), sizeEvent->size().height());
    SubTextEdit->resize(sizeEvent->size().width()-32, sizeEvent->size().height());
}
